  --
  -- Developer : Andrew Tunnecliffe 
  -- Contact: andrew.207@gmail.com http://www.atunnecliffe.com
  -- Date : Jan-2014
  -- All Code (C) 2014 Andrew Tunnecliffe
  -- 

block = {}
 
-- Constructor
function block:new(x, y, width, height)
    -- define our parameters here
    local object = {
    x = x,
    y = y,
    yOrigin = y,
    accelaration = 2,
    ySpeed = 0,
    xSpeed = 0,
    xInt = x,
    yInt = y,
    width = width,
    height = height,
    activatedTop = false,
    activatedBottom = false,
    activatedLeft = false,
    activatedRight = false,
    bumped = false,
    bumping = false,
    isBlock = true,
    last = {},
    current = {}
    }
    setmetatable(object, { __index = platform })
    return object
end

function block:draw()
  g.rectangle("fill", self.x, self.y, self.width, self.height)
  self:update(dt)
  if debug then
    g.setColor(255,255,0)
    g.line(self:getRightEdge(), self.y - self.height, self:getRightEdge(), self.y + self.height * 2)
    g.line(self:getLeftEdge(), self.y - self.height, self:getLeftEdge(), self.y + self.height * 2)
    g.line(self.x - self.width, self:getTopEdge(), self.x + self.width * 2, self:getTopEdge())
    g.line(self.x - self.width, self:getBottomEdge(), self.x + self.width * 2, self:getBottomEdge())
    g.setColor(255,255,0)
  end
end

function block:update(dt)

  if self.bumped == true then self.yInt = self.y - 10 self.bumped = false end
  
  yDiff = self.yInt - self.y    
  
  if yDiff > (self.yInt - self.y)/2 then -- if we're less than half way
    self.y = self.y + 20 * dt -- accelarate
  else
    self.y = self.y - 20 * dt
  end 
  
end

function block:bump()
  self.bumped = true
end

function block:getRightEdge(dt) 
  return self.x + self.width
end

function block:getLeftEdge() 
 return self.x  
end

function block:getTopEdge() 
 return self.y  
end

function block:getBottomEdge() 
 return self.y + self.height  
end