  --
  -- Developer : Andrew Tunnecliffe 
  -- Contact: andrew.207@gmail.com http://www.atunnecliffe.com
  -- Date : Jan-2014
  -- All Code (C) 2014 Andrew Tunnecliffe
  -- 

camera = {}
 
-- Constructor
function camera:new(rightOffset, leftOffset)
    -- define our parameters here
    local object = {
      x = 0,
      y = 0,
      obj = {toFollow},
      offset = rightOffset,
      offsetInt = rightOffset,
      rightOffset = rightOffset,
      leftOffset = leftOffset,
      maxCamMoveSpeed = 6,
      distance = 1
    }
    setmetatable(object, { __index = camera })
    return object
end

function camera:addPlayer(toFollow)
  table.insert(self.obj, toFollow)
end

function math.clamp(low, n, high) return math.min(math.max(low, n), high) end

function camera:update(dt)
  
  -- gets current target, which is middle of all players. 
  local avgx = 0
  local avgxSpeed = 0
  local xSpeedMax = 0
  local avgy = 0
  local i = 0
  local maxX = -99999
  local minX = 99999
  for _,v in ipairs(self.obj) do 
    avgx = avgx + v.x
    avgxSpeed = avgxSpeed + v.xSpeed
    avgy = avgy + v.y
    xSpeedMax = v.xSpeedMax
    if v.x > maxX then maxX = v.x end
    if v.x < minX then minX = v.x end
    i = i + 1
  end
  self.distance = maxX - minX
  avgx = avgx / i
  avgxSpeed = avgxSpeed / i
  avgy = avgy / i
  
  local percentage = self.distance / (WIDTH*SCALE)
  self.distance = percentage
  
  
  offsetDiff = self.offsetInt - self.offset;
  
  if offsetDiff > 1 or offsetDiff < -1 then
		if avgxSpeed ~= 0 then
      self.offset = self.offset + offsetDiff * 2 * dt
    else
      self.offset = self.offset + offsetDiff * 1 * dt
    end
	else
		self.offset = self.offsetInt;
  end
  
  self.offset = -WIDTH*SCALE/2
  
  xDiff = -avgx - self.x - self.offset;
  
  percentage = avgxSpeed / xSpeedMax
  if percentage < 0 then percentage = -percentage end
  percentage = percentage * self.maxCamMoveSpeed
  
  if xDiff > 10 or xDiff < -10 then
    if avgxSpeed ~= 0 then
      self.x = self.x + xDiff * percentage * dt
    else
      self.x = self.x + xDiff * 2 * dt;
    end
	else
		self.x = -avgx - self.offset;
  end

  --self.y = -self.obj.y
  --if self.y > GROUND_HEIGHT then self.y = GROUND_HEIGHT end
  --if self.y < -GROUND_HEIGHT then self.y = -GROUND_HEIGHT end
  
  self.x = math.clamp(WIDTH*SCALE, self.x, 0)
  self.y = 150
  --self.x = 0
end

function camera:movingRight() 
  self.offsetInt = self.rightOffset
end

function camera:movingLeft()
  self.offsetInt = self.leftOffset
end